/*
 *	DEMONSTRATION OF PLOTTING PROCEDURES.
 *	PLOT HILBERT CURVES. PROGRAM FREELY ADAPTED FROM
 *	"ALGORITHMS + DATA STRUCTURES = PROGRAMS"
 *	  NIKLAUS WIRTH, PRENTICE-HALL, INC.
 *	  ENGLEWODD CLIFFS, NEW JERSEY
 *
 *	ADAPTATION BY ANDREW LUEBKER, CARLETON COLLEGE,
 *	NORTHFIELD, MN. 55057
 */

CONST
  h0=768;
VAR
  i,j,h,n,x,y,x0,y0,oldx,oldy:integer;

  PROCEDURE setplop;
   BEGIN
     move(x,y);
   END;
  PROCEDURE plop;
   BEGIN
     draw(x,y);
     oldx:=x; oldy:=y;
   END;
  PROCEDURE endplop;
   BEGIN
     endplot;
     writeln(chr(7))
   END;
  PROCEDURE starplop;
   BEGIN
     initplot;
     move(0,0);
   END;
  PROCEDURE a(i:integer); FORWARD;
  PROCEDURE b(i:integer); FORWARD;
  PROCEDURE c(i:integer); FORWARD;
  PROCEDURE d(i:integer); FORWARD;
  PROCEDURE a;
   BEGIN
     IF i>0
      THEN
       BEGIN
	 d(i-1); x:=x-h; plop;
	 a(i-1); y:=y-h; plop;
	 a(i-1); x:=x+h; plop;
	 b(i-1)
       END
   END;
  PROCEDURE b;
   BEGIN
     IF i>0
      THEN
       BEGIN
	 c(i-1); y:=y+h; plop;
	 b(i-1); x:=x+h; plop;
	 b(i-1); y:=y-h; plop;
	 a(i-1)
       END
   END;
  PROCEDURE c;
   BEGIN
     IF i>0
      THEN
       BEGIN
	 b(i-1); x:=x+h; plop;
	 c(i-1); y:=y+h; plop;
	 c(i-1); x:=x-h; plop;
	 d(i-1)
       END
   END;
  PROCEDURE d;
   BEGIN
     IF i>0
      THEN
       BEGIN
	 a(i-1); y:=y-h; plop;
	 d(i-1); x:=x-h; plop;
	 d(i-1); y:=y+h; plop;
	 c(i-1)
       END
   END;
 BEGIN
   rewrite(output,'TT:');
    REPEAT
     write('LEVELS? ');
     readln(n);
     IF n<1
      THEN write('MUST BE GREATER THAN 0...')
    UNTIL n>0;
   starplop;
   erase;
      i:=0; h:=h0; x0:=h DIV 2; y0:=x0;
       REPEAT /* PLOP HILBERT CURVE OF ORDER I */
	i:=i+1; h:=h DIV 2;
	x0:=x0+(h DIV 2); y0:=y0+(h DIV 2);
	x:=x0; y:=y0;
	    setplop;
	    a(i)
       UNTIL i=n;
   endplop
 END.
