/*
 *	RND.PAS
 *	Eric Youngdale
 *	Carleton College
 *	Northfield, Mn. 55057
 *
 *	Psuedo-random number generator for OMSI Pascal-1
 *
 *	Routine similar (if not the same) as the random number
 *	sequence in BASIC-PLUS under RSTS V6C.
 *
 *	Use:
 *		RND is a real function of no arguments.
 *		RANDOMIZE is a procedure with no arguments.
 *
 *	Converted to look similar to BASIC-PLUS by Les LaCroix,
 *	   Carleton College.
 *
 *	Note:
 *	  The routines write values to program sections, and thus
 *	  cannot be overlaid or shared.
 */

 FUNCTION RND:REAL;
VAR TEMP:REAL;
  BEGIN
   /*$C
	SETD
	LDF	RSEED,%1
	DIVF	RMOD,%1
	MODF	RMUL,%1
	STCDF	%1,TEMP(%6)
	MULF	RMOD,%1
	STF	%1,RSEED
	BR	RNDEXT
RSEED:	.FLT4	6715.
RMOD:	.FLT4	2147483648.
RMUL:	.FLT4	65539.
RNDEXT:	SETF
*/
  RND:=TEMP
  END /* RND */;

PROCEDURE RANDOMIZE;
VAR
 M1:REAL;
 M2:INTEGER;
BEGIN
   M1 := TIME*21600.+3.14159;
   /*$C
	SETD
	LDCFD	M1(%6),%1
	STF	%1,RSEED
	SETF
   */
   FOR M2 := 1 TO 10 DO M1 := RND
END /* RANDOMIZE */;
