/*	Permission is hereby granted to republish,
 *	but not for profit, any or all of this program,
 *	provided that this copyright notice is included
 *
 *	Copyright 1978, Oregon Minicomputer Software, Inc.
 *		2340 SW Canyon Road
 *		Portland, Oregon 97201
 *		(503) 226-7760
 */


/*
 *	MODIFIED TO RUN WITH VAX-11 PLOTTING ROUTINES.
 *	LES LACROIX
 *	CARLETON COLLEGE
 *	NORTHFIELD, MN. 55057
 */

CONST	PI=3.14159265; MAXPOINT=50;

VAR	POINT, POINTS, LINE, LINES: INTEGER;
	RADIUS: REAL;
	SINTAB,COSTAB: ARRAY[1..MAXPOINT] OF REAL;
	OUT: TEXT;

BEGIN
	REWRITE(OUT,'TT:');
	REPEAT
	   WRITE(OUT,'Points: '); BREAK(OUT); READLN(POINTS);
	UNTIL (POINTS>0) AND (POINTS<=MAXPOINT);
	WRITE(OUT,'Lines/point: '); BREAK(OUT); READLN(LINES);
	WHILE (LINES<1) DO
	BEGIN
	   WRITE(OUT,'Must be >0 ... lines/point: '); BREAK(OUT);
	   READLN(LINES);
	END;

	INITPLOT; ERASE;
	PLOT.XSCALE:= 380; PLOT.YSCALE:= 380;
	PLOT.XOFFSET:= 512; PLOT.YOFFSET:= 380;

	FOR POINT:= 1 TO POINTS DO
	BEGIN
	   SINTAB[POINT]:= SIN(2*PI*(POINT/POINTS));
	   COSTAB[POINT]:= COS(2*PI*(POINT/POINTS));
	   MOVE(0,0); DRAW(COSTAB[POINT],SINTAB[POINT]);
	END;

	FOR LINE:= 1 TO LINES DO
	BEGIN
	   MOVE(LINE/LINES,0);
	   FOR POINT:= 1 TO POINTS DO
	   BEGIN
	      IF ODD(POINT)
	         THEN RADIUS:= 1.0-(LINE-1)*(1.0/LINES)
	         ELSE RADIUS:= LINE*(1.0/LINES);
	      DRAW(RADIUS*COSTAB[POINT],RADIUS*SINTAB[POINT]);
	   END
	END;
	ENDPLOT;
END.
