      INTEGER*4 FUNCTION TBS_DIR_MAIN(START_DIR,TBS_DIR_USER,MAX_LEVEL)
C**   *******************************
C
C++
C
C FUNCTION:	To scan the ODS-2 directory structure starting at
C		the directory specified in the START_DIR argument
C		and call an action routine (TBS_DIR_USER) for
C		every file listed in the directory structure.
C
C--
C
      CHARACTER*(*) START_DIR
      CHARACTER*80 START_DIR_FILE,DIR_FILES(8),HEADER_FILE
      CHARACTER*80 FULL_NAME
      CHARACTER*8 DEVICE
      CHARACTER*84 DIRECTORIES(8)
      CHARACTER*12 RESPONSE
      CHARACTER*5 VERSION
C
      INTEGER*4 LBRACK,RBRACK,DOT,COLON,LEVEL,ISTATUS
      INTEGER*4 HUNIT,UNITS(8),NBYTES,NVERS,LOC_FIRST_VERS
      INTEGER*4 WIDTH,IHREC,IHBASE,LOC_THIS_VERS
      INTEGER*4 ID_LIST(64),SEQ_LIST(64),VER_LIST(64)
C
      CHARACTER*20 TBS_DIR_NAME
      CHARACTER*132 TBS_DIR_USER
      LOGICAL TBS_ERROR,TBS_DIR_DIR
      EXTERNAL TBS_ERROR,TBS_DIR_DIR
      INTEGER*4 TBS_FIND_UNIT,TBS_FREE_UNIT,TBS_LEN,TBS_DIR_SEQ
      INTEGER*4 TBS_DIR_USED,TBS_CNV_DIR
      EXTERNAL TBS_FIND_UNIT,TBS_FREE_UNIT,TBS_LEN,TBS_DIR_SEQ
C
      INTEGER*2 MAX_LEVEL
C
      BYTE BYTES(512),HBYTES(512)
      INTEGER*2 WORDS(256),HEADER(256)
      CHARACTER*512 CHARS
      CHARACTER*19 NAME
      EQUIVALENCE (BYTES(1),WORDS(1))
      EQUIVALENCE (HBYTES,CHARS),(HBYTES,HEADER)
      EQUIVALENCE (BYTES(5),NAME)
C
C
      RESPONSE='CONTINUE'
      TBS_DIR_MAIN=1
C
C
C** DERIVE THE FILE NAME WHICH IS THE START_DIR DIRECTORY FILE.
      IERR=TBS_CNV_DIR(START_DIR,START_DIR_FILE)
D     WRITE(6,28) START_DIR(1:TBS_LEN(START_DIR)),
D    +            START_DIR_FILE(1:TBS_LEN(START_DIR_FILE))
D  28 FORMAT(' START_DIR=',A,', START_DIR_FILE=',A)
      IF(IERR.EQ.0) GO TO 40
      WRITE(6,30) START_DIR(1:TBS_LEN(START_DIR))
   30 FORMAT(' CANNOT TRANSLATE ',A)
      TBS_DIR_MAIN=2
      RETURN
C
C
C** INITIALIZE STACKS
   40 CONTINUE
      LEVEL=1
      DIRECTORIES(LEVEL)=START_DIR
      DIR_FILES(LEVEL)=START_DIR_FILE
C
C** DERIVE DEVICE FROM STARTING DIRECTORY.
      COLON=INDEX(START_DIR,':')
      IF(COLON.GT.0) THEN
         DEVICE=START_DIR(1:COLON)
      ELSE
         DEVICE=' '
      ENDIF
C
C** OPEN FILE CONTAINING HEADER INFO
      ISTATUS=TBS_FIND_UNIT(HUNIT)
      IF(TBS_ERROR(ISTATUS)) CALL TBS_DIR_ERROR('HEADER FILE',ISTATUS)
      HEADER_FILE='[0,0]INDEXF.SYS'
      IF(DEVICE.NE.' ') HEADER_FILE=
     +   DEVICE(1:COLON)//
     +   HEADER_FILE(1:TBS_LEN(HEADER_FILE))
D     WRITE(6,89) HEADER_FILE(1:TBS_LEN(HEADER_FILE))
D  89 FORMAT(' HEADER_FILE=',A)
      OPEN(UNIT=HUNIT,NAME=HEADER_FILE,TYPE='OLD',SHARED,
     +          READONLY,ACCESS='DIRECT')
      READ(HUNIT'2,ERR=880) WORDS
      IHBASE=WORDS(8)*4+WORDS(17)
C
C** READ HEADER FOR HEADER FILE ITSELF.
      IHREC=IHBASE+1
      READ(HUNIT'IHREC) HEADER
      IHLAST=TBS_DIR_USED(HEADER)
C
C
C** OPEN NEXT DIRECTORY FILE
  100 CONTINUE
      ISTATUS=TBS_FIND_UNIT(UNITS(LEVEL))
      IF(TBS_ERROR(ISTATUS)) CALL TBS_DIR_ERROR('SUB-DIRECTORY',ISTATUS)
D     WRITE(6,108) LEVEL,DIR_FILES(LEVEL)(1:TBS_LEN(DIR_FILES(LEVEL)))
D 108 FORMAT(' AT LEVEL ',I2,' OPENING ',A)
      OPEN(UNIT=UNITS(LEVEL),NAME=DIR_FILES(LEVEL),SHARED,ERR=120,
     +     READONLY,ACCESS='SEQUENTIAL',TYPE='OLD')
      GO TO 200
C
C
C** ERROR OPENING DIRECTORY FILE WHICH SHOULD HAVE BEEN THERE.
  120 CONTINUE
      WRITE(6,130) DIR_FILES(LEVEL)(1:TBS_LEN(DIR_FILES(LEVEL)))
  130 FORMAT(' ERROR OPENING DIRECTORY ',A)
      GO TO 400
C
C
C** READ NEXT FILE NAME 
  200 CONTINUE
      READ(UNITS(LEVEL),210,END=400,ERR=800) NBYTES,
     +                                       (BYTES(I),I=1,NBYTES)
  210 FORMAT(Q,512A1)
C
C** ASSEMBLE VERSION LIST
      LOC_FIRST_VERS=(BYTES(4)+1)/2+3
      NVERS=(NBYTES/2-LOC_FIRST_VERS+1)/4
      DO 230 IV=1,NVERS
      LOC_THIS_VERS=LOC_FIRST_VERS+(IV*4)-4
      ID_LIST(IV)=WORDS(LOC_THIS_VERS+1)
      SEQ_LIST(IV)=WORDS(LOC_THIS_VERS+2)
      VER_LIST(IV)=WORDS(LOC_THIS_VERS)
  230 CONTINUE
C
C
C
C** FOR EACH FILE IN VERSIONS LIST...
C** CREATE FULL NAME, READ HEADER INFO, CALL TBS_DIR_USER
      DO 250 IV=1,NVERS
C
      IHREC=IHBASE+ID_LIST(IV)
      READ(HUNIT'IHREC,ERR=242) HEADER
      GO TO 243
C
  242 CONTINUE
      WRITE(6,888) TBS_DIR_NAME(HEADER),IHREC,ID_LIST(IV),IHLAST
  888 FORMAT(1X,A,' IHREC=',I5,' ID=',I5,' IHLAST=',I5)
      GO TO 250
C
  243 CONTINUE
      CALL FOR$CNV_OUT_I(%VAL(VER_LIST(IV)),VERSION)
      LEFT_DIGIT=5
      IF(VER_LIST(IV).GT.9) LEFT_DIGIT=4
      IF(VER_LIST(IV).GT.99) LEFT_DIGIT=3
      IF(VER_LIST(IV).GT.999) LEFT_DIGIT=2
      IF(VER_LIST(IV).GT.9999) LEFT_DIGIT=1
      FULL_NAME=NAME(1:BYTES(4))//';'//VERSION(LEFT_DIGIT:5)
D     WRITE(6,289) FULL_NAME
D 289 FORMAT(' FULL NAME=',A)
C
      CHARS(77:96)=FULL_NAME(1:20)
D     WRITE(6,287) TBS_DIR_SEQ(HEADER),SEQ_LIST(IV),IV
D 287 FORMAT(' HDR SEQ = ',I5,' SEQ LIST = ',I5,' IV = ',I2)
      IF(TBS_DIR_SEQ(HEADER).EQ.SEQ_LIST(IV)) GO TO 245
      FULL_NAME=TBS_DIR_NAME(HEADER)
      WRITE(6,244) FULL_NAME(1:TBS_LEN(FULL_NAME))
  244 FORMAT(1X,A,' IS BEING CHANGED.')
      GO TO 250
C
  245 CONTINUE
      IF(RESPONSE.EQ.'SKIP-TO-DIR' .AND.
     +   .NOT. TBS_DIR_DIR(HEADER)) GO TO 200
C
      RESPONSE=TBS_DIR_USER(DIRECTORIES(LEVEL),IV,NVERS,HEADER,LEVEL,1)
C
      IF(RESPONSE.EQ.'STOP') GO TO 900
C
      FULL_NAME=TBS_DIR_NAME(HEADER)
      IF(FULL_NAME(1:6).EQ.'000000') GO TO 200
      IF(TBS_DIR_DIR(HEADER) .AND. LEVEL.LT.MAX_LEVEL) GO TO 300
C
      IF(RESPONSE.EQ.'SKIP-TO-DIR') GO TO 200
  250 CONTINUE
      GO TO 200
C
C
C** PROCESS SUB-DIRECTORY. ADVANCE TO NEXT LEVEL.
  300 CONTINUE
      LEVEL=LEVEL+1
      IF(LEVEL.GT.8) GO TO 840
      IF(RESPONSE.EQ.'SKIP-TO-DIR') RESPONSE='CONTINUE'
      RBRACK=INDEX(DIRECTORIES(LEVEL-1),']')
      DOT=INDEX(NAME,'.')
      DIRECTORIES(LEVEL)=DIRECTORIES(LEVEL-1)(1:RBRACK-1)//
     +                   '.'//
     +                   NAME(1:DOT-1)//']'
      DIR_FILES(LEVEL)=DIRECTORIES(LEVEL-1)(1:RBRACK)//
     +                NAME(1:BYTES(4))
      GO TO 100
C
C
C** END OF SUB-DIRECTORY FOUND.  BACKUP ONE LEVEL.
  400 CONTINUE
      IF(LEVEL.LE.1) GO TO 900
      IF(RESPONSE.EQ.'SKIP-TO-DIR') RESPONSE='CONTINUE'
      CLOSE(UNIT=UNITS(LEVEL),DISP='KEEP')
      ISTATUS=TBS_FREE_UNIT(UNITS(LEVEL))
      LEVEL=LEVEL-1
      GO TO 200
C
C
C** ERRORS
  800 CONTINUE
      PRINT 810,DIR_FILES(LEVEL)(1:TBS_LEN(DIR_FILES(LEVEL)))
  810 FORMAT(' ERR= BRANCH TAKEN READING ',A)
      GO TO 900
C
  820 CONTINUE
      PRINT 830,NAME(1:BYTES(4))
  830 FORMAT(' FILE IS BEING CHANGED: ',A)
      GO TO 200
C
C** TOO DEEP NESTING OF SUB-DIRECTORIES
  840 CONTINUE
      LEVEL=LEVEL-1
      PRINT 850
  850 FORMAT(' TOO DEEP NESTING OF SUBDIRECTORIES.')
      PRINT 855,DIRECTORIES(LEVEL)(1:TBS_LEN(DIRECTORIES(LEVEL)))
  855 FORMAT(1X,A,' IGNORED.')
      GO TO 200
C
  880 CONTINUE
      PRINT *,'ERROR READING HOME BLOCK OF HEADER FILE.'
      CALL EXIT
C
C
C** NORMAL END OF PROGRAM
  900 CONTINUE
      DO 920 LEV=1,LEVEL
      ISTATUS=TBS_FREE_UNIT(UNITS(LEV))
      CLOSE(UNIT=UNITS(LEV),DISP='KEEP')
  920 CONTINUE
      ISTATUS=TBS_FREE_UNIT(HUNIT)
      CLOSE(UNIT=HUNIT,DISP='KEEP')
      RETURN
      END

      LOGICAL FUNCTION TBS_ERROR(VALUE)
C**   **************************
C++
C
C  FUNCTION:
C
C	This routine will return TRUE if the value passed is
C	a standard status value representing an error, and
C	FALSE if the value is not an error.
C
C  CALLING SEQUENCE:
C
C	ISTATUS=<any library function which returns a standard status>
C	IF(TBS_ERROR(ISTATUS)) GO TO 800
C
C  INPUT PARAMETERS:
C
C	VALUE -	A 32-bit standard status value as listed
C			in the file ERRVAL.INC
C
C  OUTPUT PARAMETERS: NONE
C
C  IMPLICIT INPUTS: NONE
C
C  IMPLICIT OUTPUTS: NONE
C
C  COMPLETION STATUS: NONE
C
C  SIDE EFFECTS: NONE
C
C--
C
      INCLUDE 'DIRINCL.INC'
C
      INTEGER*4 VALUE
C
      IF(VALUE.EQ.TBS_WARNING .OR.
     +   VALUE.EQ.TBS_SERIOUS .OR.
     +   VALUE.EQ.TBS_FATAL) THEN
            TBS_ERROR=.TRUE.
      ELSE
            TBS_ERROR=.FALSE.
      ENDIF
      RETURN
      END

      INTEGER*4 FUNCTION TBS_CNV_DIR(DIR,FNAME)
C**   ******************************
C
C++
C FUNCTION:	Convert a directory spec of the form DDCU:[D.SD1.SD2...]
C		into a file name of the form DDCU:[D.SD1...]SDN.DIR
C
      CHARACTER*(*) DIR
      CHARACTER*(*) FNAME
C
      IRIGHT=INDEX(DIR,']')
      IF(IRIGHT.EQ.0) GO TO 800
      DO 200 IC=1,IRIGHT
      ICC=IRIGHT-IC
      IF(DIR(ICC:ICC).NE.'.') GO TO 140
      FNAME=DIR(1:ICC-1)//']'//DIR(ICC+1:IRIGHT-1)//'.DIR'
      GO TO 900
C
  140 CONTINUE
      IF(DIR(ICC:ICC).NE.'[') GO TO 200
      FNAME=DIR(1:ICC-1)//'[000000]'//DIR(ICC+1:IRIGHT-1)//'.DIR'
      GO TO 900
C
  200 CONTINUE
      TBS_CNV_DIR=1
      RETURN
C
  800 CONTINUE
      TBS_CNV_DIR=2
      RETURN
C
  900 CONTINUE
      TBS_CNV_DIR=0
      RETURN
      END

C++
C
C TITLES: TBS_GET_UNIT
C	 TBS_FIND_UNIT
C	 TBS_FREE_UNIT
C	 TBS_COUNT_UNIT
C
C FACILITY:
C
C	TBS Library of FORTRAN callable routines.  This facility
C	is available by reference to the appropriate library
C	file in tbs_library:.
C
C ABSTRACT:
C
C	Allocation and deallocation of FORTRAN I/O units is
C	managed by use of these routines.  If Library routines which
C	must allocate units are called in a user's program,
C	these routines should be called to obtain all I/O unit
C	numbers used in the program.  This is he only way to
C	insure that the Library routines will not reuse the
C	same unit numbers.  All Library routines call these
C	routines to obtain I/O units.
C
C	TBS_GET_UNIT will allow the user to request use of a
C	specific unit.  If it has already been allocated a free
C	one will be allocated from the range 20-99.  No unit number
C	below 20 is searched when a search is made of free units
C	so these units can be used without regard to conflicts
C	with Library procedure usage.  Any unit number can be
C	requested via TBS_GET_UNIT of the range 1-99.  Units less
C	20 must be specifically requested.  TBS_COUNT_UNIT will
C	count all units allocated from 1 to 99.
C
C ENVIRONMENT:
C
C	Should run in any access mode and should be AST reentrant.
C
C AUTHOR:
C
C	Doug Chamberlin		July 1979
C
C MODIFIED BY:
C
C--

      INTEGER FUNCTION TBS_GET_UNIT(UNIT)
C**   *****************************
C++
C  FUNCTION:
C
C	This routine returns a FORTRAN I/O unit number to the
C	calling program by allocating it from a pool of unused
C	unit numbers.
C
C  CALLING SEQUENCE:
C
C	IU=0
C	STATUS=TBS_GET_UNIT(IU)
C
C	or
C
C	IU=<any integer from 1 to 99>
C	STATUS=TBS_GET_UNIT(IU)
C
C INPUT PARAMETERS:
C
C	UNIT -	If UNIT is set to 0 before the call a free unit
C		number will be found and returned in UNIT.
C		If UNIT is non_zero then that unit number is
C		first checked to see if it is free and is assigned
C		if so.  If not free, the same search is performed
C		and UNIT is returned with a another number.
C
C OUTPUT PARAMETERS:
C
C	UNIT - Returned with obtained unit number.  If return status
C		is not TBS_SUCCESS, UNIT is returned undefined.
C
C IMPLICIT INPUTS:
C
C	UNIT_TABLE -	This table retains count of unit numbers
C			in use.  It is in The named COMMON block
C			/TBS_UNITCOM/.
C
C IMPLICIT OUTPUTS:
C
C	UNIT_TABLE -	See IMPLICIT INPUTS.
C
C COMPLETION STATUS:
C
C	TBS_NORMAL if successful.
C	TBS_ERROR if unit number out-of-range on call
C
C	Note that other values can be passed through from
C	TBS_FIND_UNIT.
C
C SIDE EFFECTS:
C
C	Normal returns always result in change to UNIT_TABLE.
C
C--
C
      INCLUDE 'DIRINCL.INC/LIST'
C
      INTEGER*4 UNIT
      INTEGER*4 UNIT_TABLE
      COMMON /TBS_UNITCOM/ UNIT_TABLE(99)
C
      IF(UNIT.GT.0 .AND. UNIT.LE.99) THEN
            IF(UNIT.GT.0) THEN
                  IF(UNIT_TABLE(UNIT).EQ.0) THEN
                        UNIT_TABLE(UNIT)=UNIT_TABLE(UNIT)+1
                        TBS_GET_UNIT=TBS_NORMAL
                  ELSE
                        TBS_GET_UNIT=TBS_FIND_UNIT(UNIT)
                  ENDIF
            ELSE
                  TBS_GET_UNIT=TBS_FIND_UNIT(UNIT)
            ENDIF
      ELSE
            TBS_GET_UNIT=TBS_ERROR
      ENDIF
      RETURN
      END

      INTEGER FUNCTION TBS_FIND_UNIT(UNIT)
C**   ******************************
C++
C
c FUNDTION:
C
C	Search the pool of unit numbers for an unallocated one
C	and return its number in UNIT.
C
C CALLING SEQUENCE:
C
C	STATUS=TBS_FIND_UNIT(UNIT)
c
C INPUT PARAMETERS: none
C
C OUTPUT PARAMETERS:
C
C	UNIT -	Set to value of allocated unit number.
C
C IMPLICIT INPUTS:
C
C	UNIT_TABLE -	Table of unit numbers assigned which is
C			in named COMMON block /TBS_UNITCOM/.
C
C IMPLICIT OUTPUTS:
C
C	UNIT_TABLE -	See above.
C
C COMPLETION STATUS:
C
C	TBS_NORMAL if free unit found.
C	TBS_ERROR if not.
C
C
C SIDE EFFECTS:
C
C	UNIT_TABLE is altered if normal call is made.
C
C--
      INCLUDE 'DIRINCL.INC/NOLIST'
C
      INTEGER*4 UNIT
      INTEGER*4 UNIT_TABLE
      COMMON /TBS_UNITCOM/ UNIT_TABLE(99)
C
      DO 200 I=20,99
      IF(UNIT_TABLE(I).EQ.0) THEN
            UNIT_TABLE(I)=UNIT_TABLE(I)+1
            UNIT=I
            TBS_FIND_UNIT=TBS_NORMAL
            RETURN
      ENDIF
  200 CONTINUE
      TBS_FIND_UNIT=TBS_ERROR
      RETURN
      END

      INTEGER FUNCTION TBS_FREE_UNIT(UNIT)
C**   ******************************
C++
C
C FUNCTION:
C
C	Will deallocate the indicated unit.
C
C CALLING SEQUENCE:
C
C	STATUS=TBS_FREE_UNIT(25)
C
C INPUT PARAMETERS:
C
C	UNIT -	The unit number to be freed.
C
C OUTPUT PARAMETERS: none
C
C IMPLICIT INPUTS:
C
C	UNIT_TABLE -	From COMMON block /TBS_UNITCOM/.
C
C IMPLICIT OUTPUTS:
C
C	UNIT_TABLE -	See above.
C
C COMPLETION STATUS:
C
C	TBS_NORMAL if UNIT was allocated.
C	TBS_WARNING if UNIT wasnot already allocated.
C	TBS_ERROR if UNIT is out-of-range.
C
C SIDE EFFECTS:
C
C	none
C
C--
      INCLUDE 'DIRINCL.INC/NOLIST'
C
      INTEGER*4 UNIT
      INTEGER*4 UNIT_TABLE
      COMMON /TBS_UNITCOM/ UNIT_TABLE(99)
C
      IF(UNIT.GT.0 .AND. UNIT.LE.99) THEN
            IF(UNIT_TABLE(UNIT).GT.0) THEN
                  UNIT_TABLE(UNIT)=UNIT_TABLE(UNIT)-1
                  TBS_FREE_UNIT=TBS_NORMAL
            ELSE
                  TBS_FREE_UNIT=TBS_WARN
            ENDIF
      ELSE
            TBS_FREE_UNIT=TBS_ERROR
      ENDIF
      RETURN
      END

      INTEGER FUNCTION TBS_COUNT_UNIT(COUNT)
C**   *******************************
C++
C
C FUNCTION:
C
C	Counts the I/O units allocated by TBS_GET_UNIT and
C	TBS_FIND_UNIT.  Intended to be used for debugging.
C
C CALLING SEQUENCE:
C
C	STATUS=TBS_COUNT_UNIT(COUNT)
C
C INPUT PARAMETERS: none
C
C OUTPUT PARAMETERS:
C
C	COUNT -	Set to number of allocated I/O units.
C
C IMPLICIT INPUTS:
C
C	UNIT_TABLE -	From COMMON block /TBS_UNITCOM/.
C
C IMPLICIT OUTPUTS:
C
C	UNIT_TABLE -	See above.
C
C COMPLETEION STATUS:
C
C	TBS_NORMAL is always returned.
C
C SIDE EFFECTS: none
C
C--
      INCLUDE 'DIRINCL.INC/NOLIST'
C
      INTEGER*4 COUNT
      INTEGER*4 UNIT_TABLE
      COMMON /TBS_UNITCOM/ UNIT_TABLE(99)
C
      COUNT=0
      DO 200 I=1,99
      IF(UNIT_TABLE(I).GT.0) COUNT=COUNT+1
  200 CONTINUE
      TBS_COUNT_UNIT=TBS_NORMAL
      RETURN
      END

      INTEGER FUNCTION TBS_FREE_ALL(NUMBER)
C**   *****************************
C++
C
C FUNCTION:
C
C       Will deallocate all units previously allocated.
C
C CALLING SEQUENCE:
C
C       STATUS=TBS_FREE_ALL(NUMBER)
C
C INPUT PARAMETERS: None.
C
C OUTPUT PARAMETERS:
C
C       NUMBER - The number of units that were freed (deallocated).
C
C INPLICIT INPUTS:
C
C       Uses TBS_FREE_UNIT to access the UNIT_TABLE
C
C IMPLICIT OUTPUTS: See above.
C
C COMPLETION STATUS:
C
C       TBS_NORMAL if 1 or more units were deallocated.
C       TBS_WARN   if no units were deallocated.
C
C SIDE EFFECTS: None.
C
C--
      INCLUDE 'DIRINCL.INC/NOLIST'
C
      INTEGER*4 NUMBER,STATUS
C
      NUMBER=0
      DO 100 I=20,99
      STATUS=TBS_FREE_UNIT(I)
      IF(STATUS.EQ.TBS_NORMAL) NUMBER=NUMBER+1
  100 CONTINUE
C
      IF(NUMBER.GT.0) THEN
                      TBS_FREE_ALL=TBS_NORMAL
         ELSE
                      TBS_FREE_ALL=TBS_WARN
      ENDIF
      RETURN
      END

      LOGICAL FUNCTION TBS_DIR_DIR(BYTES)
C**   ****************************
C
C++
C
C FUNCTION:	Return TRUE if the passed header is that of a
C		diretcory file, FALSE otherwise.
C
C--
C
      BYTE BYTES(256)
C
      I=LIB$EXTZV(5,1,BYTES(54))
      TBS_DIR_DIR=I 
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_SEQ(HEADER)
C**   ******************************
C
C++
C
C FUNCTION:	Extract and return the sequnce number of the file
C		which is described by the passed header.
C
C--
C
      INTEGER*2 HEADER(256)
C
      TBS_DIR_SEQ=HEADER(6)
      RETURN
      END

      SUBROUTINE TBS_DIR_ERROR(STR,ISTATUS)
C**   ****************
C JUST REPORT A UNIT ALLOCATION ERROR.
      CHARACTER*(*) STR
      INTEGER*4 ISTATUS
C
      PRINT 100,STR,ISTATUS
  100 FORMAT(' ERROR IN I/O UNIT SELECTION... ',A,1X,Z8)
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_USER(DIR,POS,NV,HDR,LEV)
C**   ***********************************
C
C++
C
C FUNCTION:	Sample action routine to receive the file names passed
C		by TBS_DIR_MAIN.
C
C--
C
      CHARACTER*(*) DIR
      CHARACTER*(20) NAME,TBS_DIR_NAME
      INTEGER*2 HDR(256)
      INTEGER*4 NV,POS
C
      INTEGER*4 TBS_LEN
      EXTERNAL TBS_LEN
C
      CHARACTER*1 TAB
      CHARACTER*1 ISD,CONTIG,LOCKED
      LOGICAL TBS_DIR_DIR,TBS_DIR_CONTIG,TBS_DIR_LOCKED
      CHARACTER*3 RECTYP,ORG
      CHARACTER*(3) TBS_DIR_RECTYP,TBS_DIR_ORG
      CHARACTER*16 PROTECT
      CHARACTER*(16) TBS_DIR_PROT
      INTEGER*2 RECSIZ
      INTEGER*4 TBS_DIR_RECSIZ,TBS_DIR_ALLOC,TBS_DIR_USED
      INTEGER*4 USED,ALLOC
      CHARACTER*24 CTIME,TBS_DIR_CTIME
      INTEGER*4 GROUP,MEMB,TBS_DIR_GROUP,TBS_DIR_MEMB
      INTEGER REV
      CHARACTER*24 RTIME,TBS_DIR_RTIME
C
      CHARACTER*80 DOTS
      DATA DOTS/'.  .  .  .  .  .  .  .  .  .  '/
      DATA TAB/'	'/
C
      IF(TBS_DIR_DIR(HDR)) THEN
         ISD='D'
      ELSE
         ISD=' '
      ENDIF
      IF(TBS_DIR_CONTIG(HDR)) THEN
         CONTIG='C'
      ELSE
         CONTIG=' '
      ENDIF
      IF(TBS_DIR_LOCKED(HDR)) THEN
         LOCKED='L'
      ELSE
         LOCKED=' '
      ENDIF
C
      RECTYP=TBS_DIR_RECTYP(HDR)
      ORG=TBS_DIR_ORG(HDR)
      RECSIZ=TBS_DIR_RECSIZ(HDR)
      PROTECT=TBS_DIR_PROT(HDR)
      ALLOC=TBS_DIR_ALLOC(HDR)
      USED=TBS_DIR_USED(HDR)
      CTIME=TBS_DIR_CTIME(HDR)
      RTIME=TBS_DIR_RTIME(HDR)
      GROUP=TBS_DIR_GROUP(HDR)
      MEMB=TBS_DIR_MEMB(HDR)
      NAME=TBS_DIR_NAME(HDR)
C
      IPOS=(LEV*3+TBS_LEN(NAME)+18)/6*6
      PRINT 200,DOTS(1:LEV*3),NAME(1:TBS_LEN(NAME)),TAB,
     +          ISD,LOCKED,CONTIG,ORG,RECTYP,RECSIZ,
     +          PROTECT(1:4),PROTECT(5:8),PROTECT(9:12),PROTECT(13:16),
     +          USED,ALLOC,CTIME,GROUP,MEMB,RTIME
  200 FORMAT(1X,A,A,1X,A1,A1,A1,A1,1X,A3,1X,A3,1X,I4,1X,
     +       '[',3(A4,','),A4,']',1X,I5,'/',I5,1X,A17,
     +       1X,'[',O3,',',O3,']',1X,A17)
      TBS_DIR_USER='CONTINUE'
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_PROT(BYTES)
C**   ************************************
C
C++
C
C FUNCTION:	Returns a 16-character string which indicates
C		the file protection as given in the passed
C		HEADER.
c
C--
C
      BYTE BYTES(512)
C
      CHARACTER*4 LIST
      DATA LIST/'RWED'/
C
      TBS_DIR_PROT='                '
      LONGWORD=BYTES(65)
      DO 200 I=1,8
      LPOS=MOD(I,4)
      IF(LPOS.EQ.0) LPOS=4
      IF(LIB$EXTZV(I-1,1,LONGWORD).EQ.0) THEN
         TBS_DIR_PROT(I:I)=LIST(LPOS:LPOS)
      ELSE
         TBS_DIR_PROT(I:I)=' '
      ENDIF
  200 CONTINUE
C
      LONGWORD=BYTES(66)
      DO 300 I=9,16
      LPOS=MOD(I,4)
      IF(LPOS.EQ.0) LPOS=4
      IF(LIB$EXTZV(I-9,1,LONGWORD).EQ.0) THEN
         TBS_DIR_PROT(I:I)=LIST(LPOS:LPOS)
      ELSE
         TBS_DIR_PROT(I:I)=' '
      ENDIF
  300 CONTINUE
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_RECTYP(BYTES)
C**   *************************************
C
C++
C
C FUNCTION:	Returns the type of record for the file described
C		by the passed header.
C
C--
C
      BYTE BYTES(512)
C
      CHARACTER*3 TYPES(3)
      BYTE CODES(3)
C
      DATA TYPES/'FIX','VAR','VFC'/
      DATA CODES/'01'X,'02'X,'03'X/
C
C** EXTRACT THE LOW 4 BITS FROM HEADER BYTE 21.
      IBYTE=LIB$EXTZV(0,4,BYTES(21))
      TBS_DIR_RECTYP='   '
      DO 200 I=1,3
      IF(IBYTE.EQ.CODES(I)) TBS_DIR_RECTYP=TYPES(I)
  200 CONTINUE
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_ORG(BYTES)
C**   *************************************
C
C++
C
C FUNCTION:	Returns the file organization for the file described
C		by the passed header.
C
C--
C
      BYTE BYTES(512)
C
      CHARACTER*3 TYPES(3)
      BYTE CODES(3)
C
      DATA TYPES/'SEQ','   ','   '/
      DATA CODES/'00'X,'02'X,'03'X/
C
C** EXTRACT THE HIGH 4 BITS FROM HEADER BYTE 21.
      IBYTE=LIB$EXTZV(4,4,BYTES(21))
      TBS_DIR_ORG='   '
      DO 200 I=1,3
      IF(IBYTE.EQ.CODES(I)) TBS_DIR_ORG=TYPES(I)
  200 CONTINUE
      RETURN
      END

      LOGICAL FUNCTION TBS_DIR_CONTIG(BYTES)
C**   *******************************
C
C++
C
C FUNCTION:	Return TRUE if the header describes a contiguous file.
C
C--
C
      BYTE BYTES(512)
C
      LONGWORD=LIB$EXTZV(7,1,BYTES(53))
      TBS_DIR_CONTIG=LONGWORD
      RETURN
      END

      LOGICAL FUNCTION TBS_DIR_LOCKED(BYTES)
C**   *******************************
C
C++
C
C FUNCTION:	Return TRUE if the header describes a LOCKED file.
C
C--
C
      BYTE BYTES(512)
C
      LONGWORD=LIB$EXTZV(6,1,BYTES(53))
      TBS_DIR_LOCKED=LONGWORD
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_RECSIZ(BYTES)
C**   *********************************
C
C++
C
C FUNCTION:	Returns the record size of the file described by the
C		passed header.
C
C--
C
      BYTE BYTES(512)
C
      CALL LIB$INSV(BYTES(23),0,16,I)
C
      TBS_DIR_RECSIZ=I
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_ALLOC(BYTES)
C**   ********************************
C
C++
C
C FUNCTION:	Return the allocated file size (in blocks)
C		of the file described in the passed header.
C
C--
C
      BYTE BYTES(512)
      INTEGER*4 I
C
      CALL LIB$INSV(BYTES(27),0,8,I)
      CALL LIB$INSV(BYTES(28),8,8,I)
      CALL LIB$INSV(BYTES(25),16,8,I)
      CALL LIB$INSV(BYTES(26),24,8,I)
C
      TBS_DIR_ALLOC=I
C
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_USED(BYTES)
C**   *******************************
C
C++
C
C FUNCTION:	Return the number of used blocks of the file
C		described by the passed header.
C
C--
C
      BYTE BYTES(512)
      INTEGER*4 I
C
      CALL LIB$INSV(BYTES(31),0,8,I)
      CALL LIB$INSV(BYTES(32),8,8,I)
      CALL LIB$INSV(BYTES(29),16,8,I)
      CALL LIB$INSV(BYTES(30),24,8,I)
C
      IF(BYTES(33).EQ.0) THEN
         TBS_DIR_USED=I-1
      ELSE
         TBS_DIR_USED=I
      ENDIF
C
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_CTIME(BYTES)
C**   ************************************
C
C++
C
C FUNCTION:	Returns the creation date and time of the file
C		described by the passed header.
C
C--
C
      BYTE BYTES(512)
C
      CHARACTER*24 TIME
C
      ISTATUS=SYS$ASCTIM(NCHARS,TIME,BYTES(99),0)
      TBS_DIR_CTIME=TIME(1:NCHARS)
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_RTIME(BYTES)
C**   ************************************
C
C++
C
C FUNCTION:	Returns the date and time last revised of the file
C		described by the passed header.
C
C--
C
      BYTE BYTES(512)
C
      INTEGER TBS_DIR_REV
      CHARACTER*24 TIME
C
      ISTATUS=SYS$ASCTIM(NCHARS,TIME,BYTES(107),0)
      IF(TBS_DIR_REV(BYTES).GT.0) THEN
         TBS_DIR_RTIME=TIME(1:NCHARS)
      ELSE
         TBS_DIR_RTIME=' '
      ENDIF
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_ETIME(BYTES)
C**   ************************************
C
C++
C
C FUNCTION:	Returns the expiration date and time of the file
C		described by the passed header.
C
C--
C
      BYTE BYTES(512)
C
      CHARACTER*24 TIME
C
      ISTATUS=SYS$ASCTIM(NCHARS,TIME,BYTES(115),0)
      TBS_DIR_ETIME=TIME(1:NCHARS)
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_BTIME(BYTES)
C**   ************************************
C
C++
C
C FUNCTION:	Returns the date and time last backed-up of the file
C		described by the passed header.
C
C--
C
      BYTE BYTES(512)
C
      CHARACTER*24 TIME
C
      ISTATUS=SYS$ASCTIM(NCHARS,TIME,BYTES(123),0)
      TBS_DIR_BTIME=TIME(1:NCHARS)
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_REV(BYTES)
C**   ******************************
C
C++
C
C FUNCTION:	Return the count of the number of times this file
C		has been revised.
C
C	WARNING:	This routine fails when the revision count
C			goes above 255.  The full revision count
C			is 16-bits but I haven't gotten around to
C			changing this routine.
C
C--
C
      BYTE BYTES(512)
C
      TBS_DIR_REV=BYTES(97)
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_MEMB(BYTES)
C**   ********************************
C
C++
C
C FUNCTION:	return the UIC MEMB number of the file.
C
C--
C
      BYTE BYTES(512)
C
      CALL LIB$INSV(BYTES(61),0,8,IMEMB)
C
      TBS_DIR_MEMB=IMEMB
      RETURN
      END

      INTEGER*4 FUNCTION TBS_DIR_GROUP(BYTES)
C**   ********************************
C
C++
C
C FUNCTION:	return the UIC GROUP number of the file.
C
C--
C
      BYTE BYTES(512)
C
      CALL LIB$INSV(BYTES(63),0,8,IGROUP)
C
      TBS_DIR_GROUP=IGROUP
      RETURN
      END

      CHARACTER*(*) FUNCTION TBS_DIR_NAME(BYTES)
C**   ***********************************
C
C++
C
C FUNCTION:	Returns the file name as stored in the header.
C
C--
C
      BYTE BYTES(512)
C
      CHARACTER*20 NAME
      BYTE NAMEBYTES(20)
C
      EQUIVALENCE (NAME,NAMEBYTES)
C
      DO 100 I=77,96
      NAMEBYTES(I-76)=BYTES(I)
  100 CONTINUE
      TBS_DIR_NAME=NAME(1:20)
      RETURN
      END

      LOGICAL FUNCTION TBS_DIR_DEL(BYTES)
C**   ****************************
C
C++
C
C FUNCTION:	Return TRUE if the passed header is that of a
C		file that is marked for delete, FALSE otherwise.
C
C--
C
      BYTE BYTES(256)
C
      I=LIB$EXTZV(7,1,BYTES(54))
      TBS_DIR_DEL=I 
      RETURN
      END
      INTEGER*4 FUNCTION TBS_LEN(STRING)
C**   **********************
C** THIS ROUTINE RETURNS THE LENGTH OF THE STRING MINUS
C** THE NUMBER OF TRAILING BLANKS.
C
      CHARACTER*(*) STRING
C
      L=LEN(STRING)
      DO 100 I=1,L
      IC=L-I+1
      IF(STRING(IC:IC).EQ.' ') GO TO 100
      TBS_LEN=IC
      RETURN
C
  100 CONTINUE
      TBS_LEN=0
      RETURN
      END

      INTEGER FUNCTION TBS_GET_CMD(STRING)
C**   ****************************
C
C++
C
C FUNCTION:	To obtain from the system the remainder of the
C		command line which was used when a foreign
C		command was issued.
C
C--
C
      CHARACTER*(*) STRING
      EXTERNAL SYS$CLI,CLI$K_GETCMD,CLI$Q_RQDESC
      INTEGER*4 REQUEST_BLK(7)
C
C** SET REQUEST-BLOCK-TYPE TO BE FOR REQUESTING THE COMMAND LINE
      REQUEST_BLK(1)=%LOC(CLI$K_GETCMD)
C
C** CALL THE SYSTEM SERVICE WITH THE REQUEST BLOCK
      ISTATUS=SYS$CLI(%REF(REQUEST_BLK))
C
      CALL TBS_COPY_STR(REQUEST_BLK(3),STRING)
      TBS_GET_CMD=ISTATUS
      RETURN
      END

      SUBROUTINE TBS_COPY_STR(STR1,STR2)
C**   ***********************
C
C++
C
C FUNCTION:	TO COPY ONE STRING TO ANOTHER.
C		This routine will allow the calling program
C		to convert the address of a descriptor into
C		a string variable.
C
C--
C
      CHARACTER*(*) STR1,STR2
C
      STR2=STR1
      IF(LEN(STR2).GT.LEN(STR1)) STR2(LEN(STR1)+1:LEN(STR2))=' '
      RETURN
      END

