C
C	FILEINFO.FOR				AUGUST 1979
C						by VICKI W. WOOLF
C
C
C+
C
C
C	VICKI W. WOOLF
C	PROGRAM OF COMPUTER GRAPHICS - CORNELL UNIVERSITY
C	120 RAND HALL    ITHACA  NEW YORK  14853   (607) 256-7444
C
C	COPYRIGHT (c) 11 NOVEMBER 1979
C
C	THE FOLLOWING SOFTWARE WAS DEVELOPED AT THE JOINT COMPUTER
C	FACILITY AT MASSACHUSETTS INSTITUTE OF TECHNOLOGY IN 
C	CAMBRIDGE, MASS. BY VICKI WOOLF.  IT WAS DEVELOPED TO ANSWER
C	SOME OF THE NEEDS OF OUR FACILITY.  IT WORKS WITHIN THAT
C	FRAMEWORK.  IT THEREFOR MAY NOT WORK AT YOUR FACILITY.  
C	IF IT DOES, THAT'S GREAT.  I DO NOT HAVE ANY INTENTIONS OF
C	SUPPORTING THIS SOFTWARE OTHER THAT MAKING IT GENERALLY
C	AVAILABLE THROUGH THE USER GROUPS.  IF YOU ALTER AND IMPROVE
C	THE SOFTWARE AND THINK THAT IT IS SOMETHING THAT I CAN
C	BENEFIT FROM, PLEASE SEND ME A COPY. THANK-YOU.
C					VICKI W. WOOLF
C
C
C
C-
C************************************************************************
C*	FILEINFO							*
C*		This program takes as input a filename and displays	*
C*	file mapping information.					*
C*									*
C*	INPUT:  FILENAME						*
C*	OUTPUT: displays full file spec, used blocks,allocated blocks	*
C*		first free byte and map of virtual to logical block 	*
C*									*
C*	NOTES:  This program allows input either via the command 	*
C*		line or if not found there, the user is prompted	*
C*		for the information.  In the case of the user being	*
C*		prompted, the program will display information of	*
C*		the requested file and then loop back asking for	*
C*		another file name.					*
C*									*
C*  TO BUILD:								*
C*	$FOR FILEINFO							*
C*	$MAC/OBJ=FILEINFOM FILEINFO                                     *
C*	$LINK FILEINFO,FILEINFOM                                        *
C*									*
C* TO USE:								*
C*	Either   $RUN FILEINFO						*
C*	  or define a foreign command					*
C*		 $FILEINFO :== $DB0:[JFLSJF]FILEINFO			*
C*									*
C* NOTE:************							*
C*	Due to foreign command implementation - program must be named	*
C*	FILEINFO....if you wish to change the name be sure to change	*
C*	the piece of code that follows the call to GET_COM.		*
C*									*
C************************************************************************
C
C

	IMPLICIT	INTEGER*4 (A-Z)
	INTEGER*4	VW$GET_FID
C
C
	COMMON / FILHDR / BUFF
C
	BYTE		BUFF(512)
	INTEGER*2	BUFF_W(256)
	INTEGER*4	BUFF_L(128)
	EQUIVALENCE	(BUFF(1),BUFF_W(1),BUFF_L(1))
C
	BYTE		BLOCK(512)
C
	INTEGER*2	NAMELEN,FULL_FILELEN
	CHARACTER*112	NAMEBUF,FULL_FILENAM
C
	CHARACTER*12	DISK,CUR_DISK
C
	INTEGER*4	STATUS
	INTEGER*2	ICHAN
C
	BYTE		IDPTR
	BYTE 		MAPPTR
	BYTE		NO_MAPWORD
	BYTE		ITEST
C
	INTEGER*2	EXTNO,FREEBYTE
	INTEGER*2	ALLOCVBN,EOFVBN
	INTEGER*2	FILNUM,FILSEQ,FILRVN
	INTEGER*2	EXTNUM,EXTSEQ,EXTRVN,EXT_NO
C
C  
C
	INTEGER*2	R$ALLOC,R$EOF,R$FREE
C
	BYTE		H$IDOF,H$MPOF,H$USE
	INTEGER*2	H$FREE
	INTEGER*2	H$FSEG,H$FNUM,H$FSEQ,H$FRVN
	INTEGER*2	H$EFNU,H$EFSQ,H$ERVN
	INTEGER*2	H$ALLOC,H$EOF
C
	INTEGER*4	ISTART_BLOCK
	CHARACTER*20	FILNAM
	BYTE		FILNAM_B(20)
	EQUIVALENCE	(FILNAM,FILNAM_B(1))
C
	BYTE		LBN_B(4)
	INTEGER*2	LBN_W(2)
	INTEGER*4	LBN
	EQUIVALENCE	(LBN,LBN_W(1),LBN_B(1))
C
C  format of map pointers
C
	BYTE		FORMAT0,FORMAT1,FORMAT2,FORMAT3
	DATA		FORMAT0	/'00'X/
	1		,FORMAT1 /'40'X/
	1		,FORMAT2 /'80'X/
	1		,FORMAT3 /'C0'X/
C
	INTEGER*2	FORMAT2_W
	DATA		FORMAT2_W /'8000'X/
	INTEGER*2	FORMAT3_W
	DATA		FORMAT3_W /'C000'X/
C
C
C
	INTEGER*4 	ICOUNT
	INTEGER*2	ICOUNT_W(2)
	BYTE		ICOUNT_B(4)
	EQUIVALENCE	(ICOUNT,ICOUNT_W(1),ICOUNT_B(1))
C
	INTEGER*4	NUM_MAPWORDS
	BYTE		NUM_MAPWORDS_B(4)
	EQUIVALENCE	(NUM_MAPWORDS,NUM_MAPWORDS_B(1))
C
	LOGICAL*1	EXT_FLAG	! flag to signal extention header
	CHARACTER*1	RESP		! temporary
	CHARACTER*20	NEWFILNAM
	CHARACTER*80	TEMP
C
	INTEGER*2	FILEID(3)
	INTEGER*2	DIRID(3)
	INTEGER*4	VBN
	INTEGER*4	MAP(2,256)
	INTEGER*2	GRP,MEM,GRPNUM,MEMNUM
C
C
C  data structure of file header
C
C
	EQUIVALENCE	(BUFF(1),IDPTR)			! ptr to id area	
	1		,(BUFF(2),MAPPTR)		! ptr to map area
	1		,(BUFF_W(8),EXTNO)		! extention number	
	1		,(BUFF(27),ALLOCVBN)		! number of allocated
	1						!   blocks	
	1		,(BUFF(31),EOFVBN)		! block number of eof
	1		,(BUFF(33),FREEBYTE)		! first free byte in
	1						! eof
	1		,(BUFF(59),NO_MAPWORD)		! number of map ptrs
	1		,(BUFF(61),MEMNUM)		! owner of file
	1		,(BUFF(63),GRPNUM)		!
	1		,(BUFF(77),FILNAM_B)		! file name
	1		,(BUFF_W(5),FILNUM)		! file index number
	1		,(BUFF_W(6),FILSEQ)		!	
	1		,(BUFF_W(7),FILRVN)		!
	1		,(BUFF(15),EXTNUM)		! index of extention
	1		,(BUFF(17),EXTSEQ)		! header
	1		,(BUFF(19),EXTRVN)		!
C
C
C
C  Data structure of Home block
C
	INTEGER*2	H$IBSZ,H$SBCL
	EQUIVALENCE	(H$IBSZ,BUFF(33))
	1		,(H$SBCL,BUFF(15))
C
	LOGICAL		FOREIGN_FLAG,OPEN_FLAG
C
	CHARACTER*6	STRIP_BLANKS,ALLOC_C,USED_C,FREE_C,IND_C,FILEID_C(3)
C
C __________________________________________________________________________
C  at last...
C
C
C  open index file....
C  
C
C
C  get filename...see if it is in command line first, otherwise prompt
C  user for it.
C
	OPEN_FLAG = .FALSE.
	CUR_DISK = 'NONE'
	FOREIGN_FLAG = .TRUE.		! signal that it was a foreign
					! command
	CALL GET_COM(NAMEBUF)
	IF (LENGTH(NAMEBUF).EQ. 8 .AND. NAMEBUF(1:8) .EQ. 'FILEINFO')
	1		 NAMEBUF = ' '
	NAMELEN = LENGTH(NAMEBUF)
	OPEN(UNIT=5,NAME='SYS$COMMAND')
5	IF (NAMELEN.GT.0) GOTO 8
	FOREIGN_FLAG = .FALSE.
6	NAMEBUF = ' '
	WRITE(5,97)
97	FORMAT(' FILEINFO>'$)
	READ(5,98,END=1000)NAMELEN,NAMEBUF
98	FORMAT(Q,A)
	GO TO 5
C
C
8	CONTINUE
	IF(NAMELEN .EQ. 1 .AND. NAMEBUF(1:1) .EQ. 'E' ) GOTO 1000
C							! exit condition
c
C
C  get diskname
C
	DISK = NAMEBUF(1:INDEX(NAMEBUF,':'))
	DSKLEN = LENGTH(DISK)
C		
	IF (DISK(1:DSKLEN) .NE. CUR_DISK(1:LENGTH(CUR_DISK)))
	1    THEN
		IF(OPEN_FLAG) CLOSE (UNIT=1)
		OPEN (UNIT=1,NAME=DISK(1:DSKLEN)//'[0,0]INDEXF.SYS'
	1		,ORGANIZATION='SEQUENTIAL'
	1		,ACCESS='DIRECT',READONLY,SHARED,TYPE='OLD'
	1		,FORM='UNFORMATTED',RECORDTYPE='FIXED'
	1		,RECORDSIZE = 128,ERR=8000)
		OPEN_FLAG = .TRUE.
		READ(1'2,ERR=8100)BUFF
		ISTART_BLOCK = H$SBCL*4 + H$IBSZ
	ENDIF
C
	EXT_FLAG = .FALSE.
C
C
C  get fileid
	DO 12 I = 1,512
 12	BUFF(I) = 0
	STATUS = VW$GET_FID(BUFF,NAMEBUF(1:NAMELEN),FULL_FILENAM
	1	,FULL_FILELEN,DIRID,FILEID)
C
	IF (.NOT. STATUS .OR. FILEID(1) .LE. 0)
	1   THEN
		CALL LIB$PUT_OUTPUT('Invalid filespec')
		IF (FOREIGN_FLAG)GO TO 1000
		GOTO 6
	ENDIF
C
C
C  get starting block number
C
C
	FILBLK = FILEID(1) + ISTART_BLOCK
C
	READ(1'FILBLK,ERR=8100)BUFF
C
	IF (EXTNO .NE. 0)		! multiheader
	1   THEN
		EXT_FLAG = .TRUE.
	ENDIF
C
	IF (SEGNO .NE. 0)
	1    THEN
		CALL LIB$PUT_OUTPUT('This is not block one of the file header')
15		CALL LIB$GET_INPUT(RESP,'Do you wish to continue ? ')
		IF (RESP .NE. 'Y' .OR. RESP .NE. 'y') GO TO 15
	ENDIF
C
C  now verify that you have the right file ....
C
C
C
C   display and store map...structure
C   save info from header
C
	USED = EOFVBN
	FREE = FREEBYTE
	ALLOC = ALLOCVBN
	GRP = GRPNUM
	MEM = MEMNUM
C
C
C  cycle through map pointers extracting the starting logical block number
C  and the number of blocks in that extent.
C	There are four different types of map pointers
C		*** come back and document them ***
C
C
	INDEXX = 0
	TOT_COUNT = 0
40	MAPP = MAPPTR
	PTR = MAPP * 2		! MAPPTR in words..need bytes
C
	PTR = PTR + 1			! ok..you did not start numbering at 0
C
	NUM_MAPWORDS = 0
	NUM_MAPWORDS_B(1) = NO_MAPWORD
	NUM_MAPWORDS = NUM_MAPWORDS * 2
	TOT_MAPWORD = 0
C
C
50	ITEST = BUFF(PTR+1) .AND. 'C0'X
	IF (ITEST .EQ. FORMAT0)
	1   THEN
		CALL LIB$PUT_OUTPUT('This is a placement word..oh well')
		ICOUNT = 0
		LBN = 0
		INCPTR = 2
	ENDIF
C
	IF (ITEST  .EQ. FORMAT1)
	1   THEN
		ICOUNT = 0
		ICOUNT_B(1) = BUFF(PTR)
		LBN_B(4) = 0			! Build LBN
		LBN_B(3) = BUFF(PTR+1) .AND. '3F'X
		LBN_B(2) = BUFF(PTR+3)
		LBN_B(1) = BUFF(PTR+2)
		INCPTR = 4
	ENDIF
C
	IF (ITEST .EQ. FORMAT2)
	1   THEN
		ICOUNT = BUFF_W((PTR+1)/2) .AND.  .NOT.FORMAT2_W
		LBN_W(1) = BUFF_W((PTR+1)/2 + 1)
		LBN_W(2) = BUFF_W((PTR+1)/2 + 2)
		INCPTR = 6
	ENDIF
C
	IF (ITEST .EQ. FORMAT3)
	1   THEN
		ICOUNT_W(1) = BUFF_W((PTR+1)/2) .AND. .NOT.FORMAT3_W
		ICOUNT_W(2) = BUFF_W((PTR+1)/2 + 1)
		LBN_W(1) = BUFF_W((PTR+1)/2 + 1)
		LBN_W(2) = BUFF_W((PTR+1)/2 + 2)
		INCPTR = 8
	ENDIF
C
C
	IF (ICOUNT .GT. 0) ICOUNT = ICOUNT + 1
	TOT_COUNT = TOT_COUNT + ICOUNT
C
C
	INDEXX = INDEXX + 1
	MAP(1,INDEXX) = ICOUNT
	MAP(2,INDEXX) = LBN
C
	PTR = PTR + INCPTR
	TOT_MAPWORD = TOT_MAPWORD + INCPTR
c
	IF (TOT_MAPWORD .LT. NUM_MAPWORDS) GO TO 50
C
C
C  ok i realize this is looking pieced....well it is....
C     check to see if this is a multiple header file
C	if so, need to cycle through the map pointers in the other
C	headers also...
C	Should actually display this information  *** future enhancement ***
C
	IF (EXT_FLAG)
	1   THEN
		FILBLK = EXTNO + '63'O
		READ(1'FILBLK,ERR=8100)BUFF
		IF (EXTNO .EQ. 0) EXT_FLAG = .FALSE.
		NUM_EXT = NUM_EXT + 1
		GO TO 40
	ENDIF
C
C  Reformat data for output..... would like to zero fill,etc.
C	Note: Version 2 supports zero fill through format specifiers
C	If you are running version 1 software, you may have to edit
C	the format statements.
C
	ENCODE(6,7031,ALLOC_C)ALLOC
	ENCODE(6,7031,USED_C)USED
	ENCODE(6,7031,FREE_C)FREE
	ENCODE(6,7031,IND_C)INDEXX
	DO 999 I = 1,3
999	ENCODE(6,7031,FILEID_C(I))FILEID(I)
	ALLOC_C = STRIP_BLANKS(ALLOC_C)
	USED_C = STRIP_BLANKS(USED_C)
	FREE_C =STRIP_BLANKS(FREE_C)
	IND_C = STRIP_BLANKS(IND_C)
	FILEID_C(1) = STRIP_BLANKS(FILEID_C(1))
	FILEID_C(2) = STRIP_BLANKS(FILEID_C(2))
	FILEID_C(3) = STRIP_BLANKS(FILEID_C(3))
7031	FORMAT(I6)
	TYPE 7030,NAMEBUF,(FILEID_C(J)(1:LENGTH(FILEID_C(J))),J=1,3)
	1	,USED_C(1:LENGTH(USED_C)),ALLOC_C(1:LENGTH(ALLOC_C))
	1	,FREE_C(1:LENGTH(FREE_C)),grp,mem
	1	,IND_C(1:LENGTH(IND_C)),((MAP(J,I),J=2,1,-1),I=1,INDEXX)
C   see note above regarding version 2 - if this causes an error.
7030	FORMAT(/10X,A<LENGTH(NAMEBUF)>
	1	/20X,'File id     :   (',A
	1		,',',A
	1		,',',A,')'
	1	/20x,'Size        :   ',A
	1		,'./',A,'.'
	1	/20X,'End of file :   ',A
	1	/20x,'File owner  :   (',o3.3,',',o3.3,')'
	1	/20x,'# map ptrs. :   ',A
	1	/25x,'LBN        # blocks'
	1	/<INDEXX>(22x,i6,6x,i6/)
	1	/)
C
C
C
	IF (.NOT. FOREIGN_FLAG)GOTO 6 
C
1000	CLOSE (UNIT = 1)
C
	STOP ' '
C
C
C
7000	FORMAT(O)
7005	FORMAT(I)
C
8000	TYPE *,'Error opening indexf.sys'
	STOP' '
C
8100	TYPE *,'Error reading indexf.sys'
	STOP ' '
C
	END
C
C********** GET_COM - Retrieve command line from DCL **********
C
	SUBROUTINE GET_COM(STRING)
	CHARACTER*(*) STRING
	INTEGER*4 GETLINE(7)
	GETLINE(1) = 1
	CALL SYS$CLI(GETLINE)
	CALL GET_STRING(GETLINE(3),STRING)
	END
C********** GET_STRING - move characters **********
C
	SUBROUTINE GET_STRING(IN,OUT)
	CHARACTER*(*) IN,OUT
	OUT = IN
	RETURN
	END


C********** LENGTH - returns length of string **********
C
C  LENGTH returns actual length of string - that is LEN
C  excluding any trailing blanks and/or nulls.

	INTEGER*4 FUNCTION LENGTH(STR)
	CHARACTER*(*) STR
	CHARACTER*1	NULL
	BYTE		NULL_B(1)
	EQUIVALENCE	(NULL,NULL_B(1))
	DATA		NULL_B /0/
	DO 10 I = LEN(STR),1,-1
		LENGTH = I
		IF(STR(I:I) .NE. ' ' .AND. STR(I:I) .NE. NULL) GO TO 20
10	CONTINUE
	LENGTH = 0
20	RETURN
	END

C********** STRIP_BLANKS - strips all blanks from input string **********
C
C  STRIP_BLANKS strips all blanks from input argument and returns
C  the result in STRIP_BLANKS

	FUNCTION STRIP_BLANKS(STRING)
	CHARACTER*(*)	STRIP_BLANKS,STRING
	INTEGER*4	LENT,I,J
	LENT = LEN(STRIP_BLANKS)
	STRIP_BLANKS=' '
	I = 1
	DO 10 J = 1, LEN(STRING)
		IF (STRING(J:J) .NE. ' ') THEN
			STRIP_BLANKS(I:I) = STRING(J:J)
			I = I + 1
			IF ( I .GT. LENT ) RETURN
		ENDIF
10	CONTINUE
	RETURN
	END


