$ ! ********** VMP library builder **********
$ !
$ ! VICKI WOOLF
$ ! PROGRAM OF COMPUTER GRAPHICS - CORNELL UNIVERSITY
$ ! 120 RAND HALL     ITHACA     NEW YORK  14853
$
$
$ !	Set up noverify, error and abort branches
$
$ OLD_VERIFY = 'F$VERIFY()
$ SET NOVERIFY
$ ON ERROR THEN GOTO ERROR_BRANCH
$ ON WARNING THEN GOTO ERROR_BRANCH
$ ON SEVERE_ERROR THEN GOTO ERROR_BRANCH
$ ON CONTROL_Y THEN GOTO ABORT_BRANCH
$
$
$ !	Compile module and create library, allowing "D" for debugging
$
$ DEBUG := FALSE
$ IF P1 .EQS. "D" THEN DEBUG := TRUE
$
$ WRITE  SYS$OUTPUT  "Compiling..."
$ IF DEBUG THEN FORTRAN/CONT=99/DEBUG/NOOPT/CHECK=ALL/D_LINES VMP
$ IF .NOT. DEBUG THEN FORTRAN/CONT=99/NODEBUG/OPTIMIZE/NOCHECK/NOD_LINES VMP
$
$ WRITE  SYS$OUTPUT "Creating library..."
$ LIBRARY/CREATE=BLOCKS:25 VMP VMP
$
$ WRITE  SYS$OUTPUT  "Inserting macro code..."
$ MACRO VMP
$ LIBRARY/INSERT VMP VMP
$
$
$ !	Type completion message and delete object modules
$
$ WRITE  SYS$OUTPUT  "--- Library re-built."
$ DELETE VMP.OBJ;*
$ IF OLD_VERIFY THEN SET VERIFY
$ EXIT
$
$
$ !	On error or abort, type error message and delete object modules
$
$ ERROR_BRANCH:
$ WRITE  SYS$OUTPUT  "--- Errors stop library re-build."
$ DELETE VMP.OBJ;*
$ IF OLD_VERIFY THEN SET VERIFY
$ EXIT %X2C
$
$ ABORT_BRANCH:
$ WRITE  SYS$OUTPUT  "--- ^Y terminates library re-build."
$ DELETE VMP.OBJ;*
$ IF OLD_VERIFY THEN SET VERIFY
$ EXIT %X614
