C********** VMPCOMMON - Principal definitions and common block **********

C Definition of NCODE function for error reporting

	CHARACTER*8	NCODE

C VMP$ contains storage local to the mapping routines

	COMMON /VMP$/	MAP_PTR
	1		,CURR_PTR
	1		,PREV_PTR
	1		,INADR(2)
	1		,RETADR(2)
	1		,IOSB(2)
	1		,ITEMP
	1		,ITEMP1
	1		,IPOS
	1		,IPOS_END
	1		,TEMP_BUFFER_B(112)

C  I/O status block - used by system service calls - usually the
C	error code is returned in the first word of this quadword.

	INTEGER*4	IOSB
	INTEGER*2	IOSB_W(4)
	EQUIVALENCE	(IOSB,IOSB_W)

C  Pointers used to control access to the linked list of file
C  descriptor blocks
C	Each file has a single block of virtual address space called
C	a file descriptor block associated with it.
C   MAP_PTR - points to the beginning of the list 
C	      0 - no files are currently mapped.
C   CURR_PTR- points to the block that is currently being referenced.
C	      Note: a copy of this block is maintained in a temporary
C		    file descriptor block (static storage).  This
C		    exists so that I could program using symbolic names
C		    in fortran.  Oh well.
C   PREV_PTR- points to the block before the current one.  This saves
C	      having to maintain backwards pointers.  It is used during
C	      the unmapping of a file to rebuild the linked list.

	INTEGER*4	MAP_PTR,CURR_PTR,PREV_PTR

C**SCRATCH AREA**
C   INADR,RETADR,ITEMP,ITEMP1,IPOS,IPOS_END are all used for 
C	temporary variables-
C	The first two are quadwords, the last four are longwords.

	INTEGER*4	INADR,RETADR,ITEMP,ITEMP1,IPOS,IPOS_END

	
C   DESCR is used to build descriptor blocks so that called routines
C   will think that they are getting character strings.


	INTEGER*4	DESCR(2)
	EQUIVALENCE	(ITEMP,DESCR)

	INTEGER*4	FILE_TYPE
	EQUIVALENCE	(ITEMP,FILE_TYPE)

	BYTE 		TEMP_BUFFER_B
	CHARACTER*112	TEMP_BUFFER_C
	INTEGER*4	TEMP_BUFFER(38)
	EQUIVALENCE	(TEMP_BUFFER_B,TEMP_BUFFER)
	EQUIVALENCE	(TEMP_BUFFER_C,TEMP_BUFFER_B)
