C*********** VMPMAPINC  -  File descriptor block template definitions *******
C
C  	VMPMAPINC.FOR	contains a common block and data structure
C		description for the temporary file descriptor block.
C		
C
C
C  constants:

	PARAMETER	FILE_DESCR_LEN = 511
	PARAMETER	FILE_DESCR_BLK = 1
	PARAMETER	FILE_DESCR_LLEN = 127
	PARAMETER	MAP$PAD	= 100
	PARAMETER	MAP$C_NEW = 1
	PARAMETER	MAP$C_OLD = 0
	PARAMETER	MAP$C_RO  = 1
	PARAMETER	MAP$C_RW  = 0

	COMMON		/VMP$DESCR/
	1			 MAP$NEXT_FILE	! ptr to next file
	1			,MAP$FILEID	! internal lunit number
	1			,MAP$MAP_ADDR(2)! beginning and ending
	1					! address of mapped file
	1			,MAP$CHANNEL	! channel number
	1			,MAP$FILE_LEN	! initial filelength
	1			,MAP$NO_EXTENDS	! number of extends on file
	1			,MAP$ALLOC_BLKS	! number of blocks allocated
	1			,MAP$EOF_BLK_NO	! block number of eof
	1			,MAP$FREE_BYTE	! first available byte of file
	1			,MAP$START_BYTE	! first block of file in windw
	1			,MAP$EXT_FILELEN! filelength including extsns
	1			,MAP$TYPE	! old (0)or new (1)
	1			,MAP$ACCESS_TYPE! r/o(1) or r/w(0)
	1			,MAP$WINDOW_SIZE! window size
	1			,MAP$WINDOW_BLKS! window size in blocks
	1			,MAP$FILESPECLEN!length of file spec
	1			,MAP$FILE_B(112)! expanded file spec.
	1					!
	1					!
	1			,MAP$FIB_DESCR
	1			,FIB$L_ACCTL_B	! access control bits
	1			,FIB$B_WSIZE	! File window size
	1			,FIB$W_FID_NUM	! file id
	1			,FIB$W_FID_SEQ	!
	1			,FIB$W_FID_RVN
	1			,FIB$W_DID_NUM	! Directory file id
	1			,FIB$W_DID_SEQ
	1			,FIB$W_DID_RVN
	1			,FIB$L_WCC	! Used for wild card operatns
	1			,FIB$W_NMCTL	! controls process of namestgs
	1			,FIB$W_EXCTL	! extend control info
	1			,FIB$L_EXSZ	! spec # blocks to move
	1			,FIB$L_EXVBN	! starting vbn for extends
	1			,FIB$B_ALOPTS	!
	1			,FIB$B_ALALIGN
	1			,FIB$W_LOC_NUM
	1			,FIB$W_LOC_SEQ
	1			,FIB$W_LOC_RVN
	1			,FIB$L
	1			,MAP$B_RECATTR	!  buffer for record attribs
	1			,ATR$L_LIST
	1			,MAP$FAB

	BYTE		FILE_DESCR(0:FILE_DESCR_LEN)
	INTEGER*4	FILE_DESCR_L(0:FILE_DESCR_LLEN)
	CHARACTER*512	FILE_DESCR_C

	EQUIVALENCE	(FILE_DESCR,MAP$NEXT_FILE)
	EQUIVALENCE	(FILE_DESCR(0),FILE_DESCR_L(0))
	EQUIVALENCE	(FILE_DESCR,FILE_DESCR_C)

	INTEGER*4	MAP$NEXT_FILE,MAP$FILEID,MAP$MAP_ADDR
	INTEGER*4	MAP$FILE_LEN,MAP$NO_EXTENDS
	INTEGER*4	MAP$CHANNEL,MAP$ALLOC_BLKS,MAP$EOF_BLK_NO
	INTEGER*4	MAP$FREE_BYTE,MAP$START_BYTE,MAP$EXT_FILELEN
	INTEGER*4	MAP$TYPE,MAP$ACCESS_TYPE
	INTEGER*4	MAP$WINDOW_SIZE,MAP$WINDOW_BLKS
	BYTE		MAP$FILE_B
	CHARACTER*112	MAP$FILESPEC
	EQUIVALENCE	(MAP$FILESPEC,MAP$FILE_B)

C  FAB

	BYTE 		MAP$FAB


C  FIB and ATTRIBUTE List
C	These will overlay the FAB since the FAB is necessary only 
C	for the initial parse and search of the name string, and no
C	channel is associated with a FAB.

	BYTE		MAP$FIB
	INTEGER*4	MAP$FIB_DESCR(2)
	PARAMETER	FIB$K_LEN = 44

	EQUIVALENCE	(MAP$FIB,FIB$L_ACCTL_B,FIB$L_ACCTL)

	BYTE		FIB$L_ACCTL_B(3)
	BYTE		FIB$B_WSIZE
	BYTE		FIB$B_ALOPTS
	BYTE		FIB$B_ALALIGN

	INTEGER*2	FIB$W_FID_NUM,FIB$W_FID_RVN,FIB$W_FID_SEQ
	INTEGER*2	FIB$W_DID_NUM,FIB$W_DID_RVN,FIB$W_DID_SEQ	
	INTEGER*2	FIB$W_LOC_NUM,FIB$W_LOC_RVN,FIB$W_LOC_SEQ

	INTEGER*2	FIB$W_NMCTL,FIB$W_EXCTL

	INTEGER*4	FIB$L_ACCTL
	INTEGER*4	FIB$L_WCC
	INTEGER*4	FIB$L_EXSZ
	INTEGER*4	FIB$L_EXVBN

	INTEGER*2	FIB$W_FID
	INTEGER*2	FIB$W_DID
	INTEGER*2	FIB$W_ALLOC,FIB$W_LOC_FID
	EQUIVALENCE	(FIB$W_FID,FIB$W_FID_NUM)
	EQUIVALENCE	(FIB$W_DID,FIB$W_DID_NUM)
	EQUIVALENCE	(FIB$W_ALLOC,FIB$W_LOC_NUM,FIB$W_LOC_FID)

C   ATTRIBUTE LIST

	INTEGER*4	ATR$L_LIST(11)			! ATTRIBUTE LIST
	INTEGER*2	ATR$W_LIST(22)
	EQUIVALENCE	(ATR$L_LIST,ATR$W_LIST)

C   ATTRIBUTES - record

	BYTE		MAP$B_RECATTR(32)
	INTEGER*2	MAP$W_RECATTR(16)
	INTEGER*4	MAP$L_RECATTR(8)
	EQUIVALENCE	(MAP$B_RECATTR,MAP$W_RECATTR,MAP$L_RECATTR)

	BYTE		MAP$B_REC_TYPE
	INTEGER*2	MAP$W_REC_ALLOC,MAP$W_REC_EOF,MAP$W_REC_FREE
	EQUIVALENCE	 (MAP$W_REC_ALLOC,MAP$B_RECATTR(7))
	1		,(MAP$W_REC_EOF,MAP$B_RECATTR(11))
	1		,(MAP$W_REC_FREE,MAP$B_RECATTR(13))
	1		,(MAP$B_REC_TYPE,MAP$B_RECATTR)

	PARAMETER	FIB$M_WRITE = '00000100'X	! SET FOR WRITE,
	1						! CLR FOR READONLY
	1		,FIB$M_NOREAD ='00000400'X	! NOREAD FOR OTHERS
	1		,FIB$M_NOWRITE='00000001'X	! NO WRITE
	1		,FIB$M_DLOCK  ='00000002'X	! ENABLE DEACC LOCK
	1		,FIB$M_SEQONLY='00000040'X	! SEQUEN. ONLY
	1		,FIB$M_REWIND ='00000008'X	!
	1		,FIB$M_READCK ='00000200'X	! Set FOR READCHECK
	1		,FIB$M_WRITECK='00000020'X
	1		,FIB$M_ALCONB ='00000002'X
	1		,FIB$M_EXTEND ='00000080'X
	1		,FIB$M_NEWVER ='00000200'X
	1		,FIB$M_FINDFID='00000800'X
	1		,FIB$M_TRUNC  ='00000100'X

	PARAMETER	SEC$M_WRT     ='00000008'X
	1		,ATR$S_RECATTR='00000020'X
	1		,ATR$C_RECATTR='00000004'X
	1		,ATR$K_EOLIST ='00000000'X
	1		,FHD$VARLEN   ='00000002'X

