$TOP:
$!  Issue instructions to the user
$TYPE SYS$INPUT 

When the screen clears, enter the notice exactly as it should appear on
the user's terminal.  A date and time will be added automatically when
the notice is sent to the user.  When finished with the notice, hit the
ESC key, followed by a CTRL-Z.

$INQUIRE DUMMY "Hit CR to proceed."
$!  Put the user into VTEDIT
$ASSIGN/USER TT SYS$INPUT
$MAKE SYSMSG.TMP
$!  Replay the notice and ask for verification
$WRITE SYS$OUTPUT "Please verify that the notice is correct:"
$TYPE SYSMSG.TMP
$INQUIRE REPLY "Is notice correct? "
$IF "''F$EXTRACT(0,1,REPLY)'" .NES. "Y" THEN $GOTO TOP
$!  Copy the correct file to SYS$MAIL
$COPY/PROT=W:R SYSMSG.TMP SYS$MAIL:SYSMSG.TXT
$DELETE SYSMSG.TMP;*
$EXIT
$!  Title:
$!	ADDNOTICE Add a new system notice
$!  Facility:
$!	System notice processing as handled by LNOTICE and NOTICE utilities.
$!  Abstract:
$!  Procedure to allow operators to define new system notices.  TECO is used
$!  to enter the message.  However, the user need not know TECO since the
$!  the notice is played back and confirmed before being placed in SYS$MAIL.
$!  Environment:
$!	DCL command interpreter.  Must be run from account with privilege
$!	to copy a file into directory SYS$MAIL.
$!  Author:
$!	Gary L. Grebus, Creation date: 9-Apr-80
$!	Computer Center
$!	Battelle Columbus Labs
$!	505 King Ave.
$!	Columbus, Ohio  43201
$!  Modified by:
$!	1.00 - Original version
$!
